package soln;

import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.util.Scanner;

import javax.net.ssl.HttpsURLConnection;

public class Labtest3_Sec02_Part1 {

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {

		/**
		 * 
		 */

		/**
		 * This labtest is based on Lab7.3. This labtest assumes you have
		 * completed this lab and builds upon it.
		 * 
		 * 
		 * [3 marks] Step 1: For the specified URL (found below), establish a
		 * connection with it and reads the returned document line by line,
		 * printing each line. At the end, print the file name of the URL (see
		 * the API for the appropriate getter)
		 * 
		 * NOTE1, found below, explains the URL a little further.
		 * 
		 * NOTE2, found below, provides a small overview of how the class URL
		 * works.
		 */

		// URL to be used:
		// http://localhost/course_archive/2010-11/W/1720/labtest/LT3/fileA.txt

		URL url = new URL(
				"http://localhost/course_archive/2010-11/W/1720/labtest/LT3/fileA.txt");
		InputStream inputStream = url.openStream();
		// System.out.println(url.getFile());

		Scanner input = new Scanner(inputStream);
		while (input.hasNext()) {
			System.out.println(input.nextLine());
		}

		System.out.println(url.getFile());

		/**
		 * [2 marks] Step 2: Below is a string variable declaration and
		 * assignment for the variable "shortFileName". On the next line, add
		 * one or more statements that will re-assign the value of
		 * "shortFileName" to be the file name of the URL, but with the initial
		 * path component stripped off. E.g., If the URL is
		 * "http://localhost/course_archive/2010-11/W/1720/labtest/LT3/fileA.txt"
		 * , then shortFileName should be assigned the string "fileA.txt"
		 * 
		 * Use the services of the string class. If you cannot solve this step,
		 * carry on with the remaining steps and leave the value of
		 * shortFileName as it is initially assigned.
		 * 
		 * 
		 */
		String shortFileName = "X";
		shortFileName = url.getFile().replaceAll("/.*/", "");
		System.out.println(shortFileName);

		/**
		 * [1 mark] Step 3: now retrieve the document at the above-named URL
		 * again and repeat the line-by-line printing. At the start of each
		 * output line, print a prefix which consists of the following four
		 * things concantenated together: the value of "shortFileName", followed
		 * by a tab, followed by a line number, followed by a tab. Start with
		 * line number 1. At the end, print two empty lines.
		 */

		inputStream = url.openStream();
		input = new Scanner(inputStream);
		int x = 1;
		while (input.hasNext()) {
			System.out.println(shortFileName + "\t" + x + "\t"
					+ input.nextLine());
			x++;
		}

		System.out.println();
		System.out.println();

		/**
		 * [3 marks] Step 3: Suppose we call the document at the URL above
		 * "document A" and we call the document at the URL named below this
		 * comment block "document B". Now retrieve both document A and document
		 * B and repeat the line-by-line printing, where the sequence of the
		 * output should be line 1 of document A, line 1 of document B, line 2
		 * of document A, line 2 of document B, .... and so on.
		 * 
		 * At the start of each output line, print the prefix as defined above
		 * to identify the source file and line number of each line. At the end,
		 * print two empty lines.
		 * 
		 * You may assume that the files have a equal number of lines.
		 */

		// URL to be used:
		// http://localhost/course_archive/2010-11/W/1720/labtest/LT3/fileB.txt

		URL url2 = new URL(
				"http://localhost/course_archive/2010-11/W/1720/labtest/LT3/fileB.txt");
		InputStream inputStream2 = url2.openStream();
		Scanner input2 = new Scanner(inputStream2);
		String shortFileName2 = url2.getFile().replaceAll("/.*/", "");

		inputStream = url.openStream();
		input = new Scanner(inputStream);

		x = 1;
		while (input.hasNext()) {
			System.out.println(shortFileName + "\t" + x + "\t"
					+ input.nextLine());
			System.out.println(shortFileName2 + "\t" + x + "\t"
					+ input2.nextLine());
			x++;
		}

		System.out.println();
		System.out.println();

		/**
		 * [3 marks] Step 4: now repeat the step above, but after each pair of
		 * lines, print out information whether the line from document A is
		 * lexicographically less than the corresponding line from document B.
		 * For each line number, you should print the shortFileName of the file
		 * that had the lexicographically smaller line.
		 * 
		 * At the end, print two empty lines.
		 * 
		 * if line A is "lexicographically less" than line B, then this means
		 * that line A would occur before line B if they were sorted in
		 * dictionary order. The compareTo method in the String class should be
		 * used, and to summarize the API, if we invoke a.compareTo(b), then the
		 * return value will be < 0 if a is lexicographically less than b, the
		 * value will be 0 if they are equal strings, and the value will be > 0
		 * if a is lexicographically larger than b.
		 * 
		 */

		inputStream2 = url2.openStream();
		input2 = new Scanner(inputStream2);
		inputStream = url.openStream();
		input = new Scanner(inputStream);

		x = 1;
		while (input.hasNext()) {
			String line1 = input.nextLine();
			String line2 = input2.nextLine();
			System.out.println(shortFileName + "\t" + x + "\t" + line1);
			System.out.println(shortFileName2 + "\t" + x + "\t" + line2);

			if (line1.compareTo(line2) < 1) {
				System.out.println(shortFileName);
			} else {
				System.out.println(shortFileName2);
			}
			x++;
		}

		System.out.println();
		System.out.println();

		/**
		 * [1 marks] Step 4: now repeat the step above, but now, for each pair
		 * of lines, print only the line that is lexicographically smaller of
		 * the two lines.
		 * 
		 * Does the limerick still make sense? :-)
		 */

		inputStream2 = url2.openStream();
		input2 = new Scanner(inputStream2);
		inputStream = url.openStream();
		input = new Scanner(inputStream);

		x = 1;
		while (input.hasNext()) {
			String line1 = input.nextLine();
			String line2 = input2.nextLine();
			if (line1.compareTo(line2) < 1) {
				System.out.println(line1);
			} else {
				System.out.println(line2);
			}
			x++;
		}

		System.out.println();
		System.out.println();

		System.out.println("**");

	}
	/**
	 * NOTE1:
	 * 
	 * This machine is running in labtest mode, which means that this machine
	 * cannot connect to the external web.
	 * 
	 * Notice that if you type http://localhost in your browser window, you see
	 * content because your browser is performing a http request to a local
	 * resource. The http request is not being made to a server on the web, but
	 * rather to a web server that is running locally (in fact, on the same
	 * computer as this app). The web server that is running locally is serving
	 * up content through the http scheme.
	 * 
	 * You can see the same content by looking at the URL using your web
	 * browser.
	 */

	/**
	 * NOTE2:
	 * 
	 * The Class URL represents a Uniform Resource Locator, a pointer to a
	 * "resource" on the World Wide Web. The pointer includes the scheme or
	 * manner with which the resource should be obtained. A common scheme is
	 * http.
	 * 
	 * A web browser will usually dereference the URL http://example.org by
	 * performing an HTTP request (such as GET) to the host at example.org. If
	 * we want to retrieve the resource from within our java app, then we must
	 * use the services of the class URL. The class provides the method
	 * openConnection(), which opens a connection to the URL the object is
	 * encapsulating. The method returns an InputStream for reading from that
	 * connection. Since our URL makes use of the http scheme, this means that
	 * in opening the connection, this method will issue a GET request to the
	 * webserver at the specified domain. If the URL specifies a scheme other
	 * than http (such as ftp or https), then the openConnection() method may
	 * behave differently (and issue a different command, depending on the
	 * specifications of the particular protocol).
	 */

}
